package com.xiaoniu.subsystem.business.controller;

import com.alibaba.nacos.common.utils.CollectionUtils;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import com.xiaoniu.common.core.result.R;
import com.xiaoniu.common.core.utils.BeanUtil;
import com.xiaoniu.common.core.utils.poi.ExcelUtil;
import com.xiaoniu.common.log.annotation.Log;
import com.xiaoniu.common.log.enums.BusinessType;
import com.xiaoniu.subsystem.business.domain.AdmissionExamination;
import com.xiaoniu.subsystem.business.domain.ExamQuestion;
import com.xiaoniu.subsystem.business.domain.dto.AdmissionExaminationDTO;
import com.xiaoniu.subsystem.business.domain.dto.AdmissionExaminationPageDTO;
import com.xiaoniu.subsystem.business.domain.vo.AdmissionExaminationPageVO;
import com.xiaoniu.subsystem.business.domain.vo.AdmissionExaminationVO;
import com.xiaoniu.subsystem.business.domain.vo.ExamQuestionVO;
import com.xiaoniu.subsystem.business.service.IAdmissionExaminationService;
import com.xiaoniu.subsystem.system.domain.Unit;
import com.xiaoniu.subsystem.system.service.IUnitService;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.Parameter;
import io.swagger.v3.oas.annotations.tags.Tag;
import jakarta.servlet.http.HttpServletResponse;
import jakarta.validation.Valid;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.List;

import static com.xiaoniu.common.security.utils.SecurityUtils.getUnitId;
import static com.xiaoniu.common.security.utils.SecurityUtils.getUserId;

/**
 * <p>
 * 入学摸底考试成绩 前端控制器
 * </p>
 *
 * @author haoxuyang
 * @since 2024-12-23 05:36:11
 */
@Slf4j
@RestController
@AllArgsConstructor
@RequestMapping("/admissionExamination")
@Tag(name = "入学摸底考试成绩表", description = "入学摸底考试成绩")
public class AdmissionExaminationController {

    private final IUnitService unitService;
    private final IAdmissionExaminationService  admissionExaminationService;




    /**
     * 详情
     */
    @GetMapping("/detail")
    @ApiOperationSupport(order = 1)
    @Operation(summary = "详情", description = "传入examinationId")
    public R<AdmissionExaminationVO> detail(@Parameter(description = "主键", required = true) @RequestParam Long examinationId) {
        AdmissionExamination detail = admissionExaminationService.getById(examinationId);
        return R.data(BeanUtil.copy(detail, AdmissionExaminationVO.class));
    }
    /**
     * 分页
     */
    @GetMapping("/page")
    @ApiOperationSupport(order = 2)
    @Operation(summary = "分页", description = "传入AdmissionExaminationPageDTO")
    public R<IPage<AdmissionExaminationPageVO>> page(@Validated AdmissionExaminationPageDTO dto) {
        IPage<AdmissionExamination> pages = admissionExaminationService.page(new Page<>(dto.getPageNum(), dto.getPageSize()),
                new LambdaQueryWrapper<AdmissionExamination>()
                        .orderByDesc(AdmissionExamination::getCreateTime)
                        .eq(AdmissionExamination::getFlightId,dto.getFlightId())
                        .like(StringUtils.isNotBlank(dto.getUserName()), AdmissionExamination::getUserName, dto.getUserName())
                        .like(StringUtils.isNotBlank(dto.getIdCard()), AdmissionExamination::getIdCard, dto.getIdCard())
                        .like(StringUtils.isNotBlank(dto.getSendingUnitName()), AdmissionExamination::getSendingUnitName, dto.getSendingUnitName())
                        .ge(dto.getTotalScore1() != null,AdmissionExamination::getTotalScore,dto.getTotalScore1())
                        .le(dto.getTotalScore2() != null,AdmissionExamination::getTotalScore,dto.getTotalScore2())
                        .eq(StringUtils.isNotBlank(dto.getEvaluationOrder()),AdmissionExamination::getEvaluationOrder,dto.getEvaluationOrder())
                        .eq(StringUtils.isNotBlank(dto.getYear()),AdmissionExamination::getYear,dto.getYear())
        );

        IPage<AdmissionExaminationPageVO> copy = BeanUtil.copy(pages, AdmissionExaminationPageVO.class);
        return R.data(copy);
    }

    /**
     * 新增
     */
    @PostMapping("/save")
    @ApiOperationSupport(order = 4)
    @Operation(summary = "新增", description = "传入AdmissionExaminationDTO")
    public R save(@Valid @RequestBody AdmissionExaminationDTO dto) {
        Unit unit = unitService.getById(getUnitId());
        AdmissionExamination copy = BeanUtil.copy(dto, AdmissionExamination.class)
                .setCreateDept(unit.getUnitId())
                .setCreateUser(getUserId())
                .setCreateTime(new Date());
        List<AdmissionExamination> one = admissionExaminationService.list(new LambdaQueryWrapper<AdmissionExamination>()
                .eq(AdmissionExamination::getUserName,copy.getUserName())
                .eq(AdmissionExamination::getFlightId,copy.getFlightId())
                .eq(AdmissionExamination::getIdCard,copy.getIdCard()));
        if (CollectionUtils.isNotEmpty(one)) {
            return R.fail("数据已存在");
        }
        return R.status(admissionExaminationService.save(copy));
    }

    /**
     * 修改
     */
    @PostMapping("/update")
    @ApiOperationSupport(order = 5)
    @Operation(summary = "修改", description = "传入AdmissionExaminationDTO")
    public R update(@Valid @RequestBody AdmissionExaminationDTO dto) {
        AdmissionExamination copy = BeanUtil.copy(dto, AdmissionExamination.class)
                .setUpdateUser(getUserId())
                .setUpdateTime(new Date());
        return R.status(admissionExaminationService.updateById(copy));
    }

    /**
     * 删除
     */
    @PostMapping("/remove")
    @ApiOperationSupport(order = 7)
    @Operation(summary = "删除", description = "传入ids")
    public R remove(@Parameter(description = "主键集合", required = true) @RequestParam String ids) {
        //List<AdmissionExamination> list = admissionExaminationService.listByIds(Arrays.stream(ids.split(",")).toList());
        return R.status(admissionExaminationService.removeByIds(Arrays.stream(ids.split(",")).toList()));
    }

    /**
     * 导出
     */
    @GetMapping("/export")
    @ApiOperationSupport(order = 3)
    @Log(title = "导出", businessType = BusinessType.EXPORT)
    @Operation(summary = "导出", description = "传入AdmissionExaminationPageDTO")
    public void export(HttpServletResponse response, @Validated AdmissionExaminationPageDTO dto) {
        List<AdmissionExamination> list = new ArrayList<>();
        if (StringUtils.isNotBlank(dto.getIds())) {
            list.addAll(admissionExaminationService.list(new LambdaQueryWrapper<AdmissionExamination>()
                    .orderByDesc(AdmissionExamination::getCreateTime)
                    .in(StringUtils.isNotBlank(dto.getIds()), AdmissionExamination::getExaminationId,
                            Arrays.stream(dto.getIds().split(",")).toList())));
        } else {
            list.addAll(admissionExaminationService.list(new LambdaQueryWrapper<AdmissionExamination>()
                    .orderByDesc(AdmissionExamination::getCreateTime)
                    .eq(AdmissionExamination::getFlightId,dto.getFlightId())
                    .like(StringUtils.isNotBlank(dto.getUserName()), AdmissionExamination::getUserName, dto.getUserName())
                    .like(StringUtils.isNotBlank(dto.getIdCard()), AdmissionExamination::getIdCard, dto.getIdCard())
                    .like(StringUtils.isNotBlank(dto.getSendingUnitName()), AdmissionExamination::getSendingUnitName, dto.getSendingUnitName())
                    .ge(dto.getTotalScore1() != null,AdmissionExamination::getTotalScore,dto.getTotalScore1())
                    .le(dto.getTotalScore2() != null,AdmissionExamination::getTotalScore,dto.getTotalScore2())
                    .eq(StringUtils.isNotBlank(dto.getEvaluationOrder()),AdmissionExamination::getEvaluationOrder,dto.getEvaluationOrder())
                    .eq(StringUtils.isNotBlank(dto.getYear()),AdmissionExamination::getYear,dto.getYear())
            ));
        }
        ExcelUtil<AdmissionExamination> excelUtil = new ExcelUtil<>(AdmissionExamination.class);
        excelUtil.exportExcel(response, list, "入学摸底考试数据");
    }

    /**
     * 导入
     */
    @PostMapping("/import")
    @ApiOperationSupport(order = 9)
    @Log(title = "入学摸底考试成绩导入", businessType = BusinessType.IMPORT)
    @Operation(summary = "导入")
    public R importData(MultipartFile file,
                        @Parameter(description = "是否支持更新", required = true)
                        @RequestParam boolean updateSupport) throws Exception {
        ExcelUtil<AdmissionExamination> util = new ExcelUtil<>(AdmissionExamination.class);
        List<AdmissionExamination> list = util.importExcel(file.getInputStream());
        return R.success(admissionExaminationService.importData(list, updateSupport));
    }

    /**
     * 模版导入
     */
    @GetMapping("/importTemplate")
    @ApiOperationSupport(order = 10)
    @Operation(summary = "导入模版下载")
    public void importTemplate(HttpServletResponse response) {
        ExcelUtil<AdmissionExamination> util = new ExcelUtil<>(AdmissionExamination.class);
        util.importTemplateExcel(response, "入学摸底考试成绩导入模版");
    }

}
